(function() {
  function onNewFocusedElement(element) {
    const tagName = element.nodeName.toLowerCase();

    console.log("The active element is ", element);

    var isEditable = false;
    if (
      tagName === "textarea" || // Check if it's a textarea
      (tagName === "input" &&
        [
          "text",
          "search",
          "email",
          "number",
          "password",
          "tel",
          "url",
          null,
        ].includes(element.getAttribute("type")))
    ) {
      console.log("The active element is editable.");
      element.removeEventListener("input", onInputChanged);
      element.addEventListener("input", onInputChanged);

      isEditable = true;
    } else if (
      tagName == "div" &&
      element.getAttribute("contenteditable") == "true"
    ) {
      console.log("The active element is editable. WPP");
      element.removeEventListener("input", onInputChanged);
      element.addEventListener("input", onInputChanged);

      isEditable = true;
    } else {
      console.log("The active element is not editable.");

      isEditable = false;
    }

    onTextFieldFocused(isEditable, isEditable ? element.value : "");
  }

  function onInputChanged(event) {
    sendOnTextFieldValueChanged(event.target.value);
  }

  function sendOnTextFieldValueChanged(text) {
    try {
      TextFieldBridge.onTextFieldValueChanged(text);
    } catch (e) {
      console.error(
        `Error sending onTextFieldValueChanged text: ${text} , error: ${e}`
      );
    }
  }

  function onTextFieldFocused(focused, value) {
    try {
      TextFieldBridge.onTextFieldFocused(focused, value,
        document.activeElement.type == 'password');
    } catch (e) {
      console.error(
        `Error sending onTextFieldFocused focused: ${focused} , value: ${value} , error: ${e}`
      );
    }
  }

  var focusedElement = document.activeElement;
  setInterval(() => {
    if (focusedElement != document.activeElement) {
      focusedElement = document.activeElement;
      if (focusedElement) {
        onNewFocusedElement(focusedElement);
      }
    }
  }, 200);

  if (focusedElement) {
    onNewFocusedElement(focusedElement);
  }
})();
