/**
 * @param {HTMLElement} element
 * @param {number} ttl
 * @returns {string | undefined}
 *
 * Start with element and find the first thumbnail image in the DOM tree
 * going up from element. If no thumbnail is found, return undefined.
 */
function findThumbnailFromVideo(element, ttl) {
    if (!element) {
        console.log("Element is not defined");
        return undefined;
    }
    console.log("elem: ".concat(element.tagName, " ttl: ").concat(ttl));
    if (ttl === 0) {
        console.log("Time to live exceeded");
        return undefined;
    }
    var img = element.querySelector("img");
    if (img) {
        console.log("Found img: ".concat(img.src));
        return img.src;
    }
    // find div with background-image
    var div = element.querySelector("div");
    if (div) {
        var bg = div.style.backgroundImage;
        if (bg) {
            var src = bg.replace(/url\(['"]?([^'"]*)['"]?\)/, "$1");
            console.log("Found div: ".concat(src));
            return src;
        }
    }
    return findThumbnailFromVideo(element.parentElement, ttl - 1);
}
/**
 *
 * @returns {string | undefined}
 */
function findThumbnail() {
    try {
        var metaOgImg = document.querySelector("meta[name='og:image']");
        if (metaOgImg) {
            return metaOgImg.content;
        }
        var metaTwitterImg = document.querySelector("meta[name='twitter:image']");
        if (metaTwitterImg) {
            return metaTwitterImg.content;
        }
        return findThumbnailFromVideo(document.querySelector("video[src]"), 5);
    }
    catch (e) {
        console.log(e);
    }
    return undefined;
}
findThumbnail();
