let port = browser.runtime.connectNative("commonext_port");

port.postMessage("WebExtension loaded");

let messageTypeJsCall = "js_call";
let messageTypeKotlinCall = "kotlin_call";
let messageTypeJsLog = "log";

//let kotlinCallCtr = 0;
//let kotlinCalls = {};

function nativeLog(s) {
  port.postMessage(s);
}

port.onMessage.addListener((message) => {
  nativeLog(`Script Received: type: ${message.type}`);
  switch (message.type) {
    case messageTypeJsCall:
      try {
        let result = eval(message.js);
        port.postMessage({
          type: message.type,
          callId: message.callId,
          result: JSON.stringify(result),
        });
      } catch (e) {
        nativeLog("error: " + e.toString());
        port.postMessage({
          type: message.type,
          callId: message.callId,
          error: e.toString(),
        });
      }
      break;
    case messageTypeKotlinCall:
      try {
        // send to background script
        //nativeLog("send to background script: " + message);
        browser.runtime.sendMessage(message);
      } catch (e) {
        nativeLog("bgPort.sendMessage: error: " + e.toString());
      }
      break;
    default:
      nativeLog("unknown message type: " + message.type);
      break;
  }
});


// PROXY BACKGROUND TO KOTLIN
let myPort = browser.runtime.connect({name:"port-from-cs"});
myPort.onMessage.addListener(function(m) {
    port.postMessage(m);
});
