(function () {
    var isIframe = window.location !== window.parent.location;
    setInterval(function () {
        var video = document.querySelector("video");
        if (video) {
            // @ts-ignore
            KotlinBridge.onPlayerStateChange(isIframe, true, !video.paused, video.src);
        }
    }, 1000);
    var videoElement = null;
    var timeUpdateCallback = function () {
        if (videoElement == null) {
            return;
        }
        var currentTime = videoElement.currentTime;
        var duration = videoElement.duration;
        // @ts-ignore
        KotlinBridge.onProgressChange(isIframe, currentTime, duration);
    };
    if (isIframe) {
        function receiver(msg) {
            var _a;
            var action = msg.data.action;
            videoElement = document.querySelector("video");
            // @ts-ignore
            KotlinBridge.log("Received message: ".concat(action, ", has video: ").concat(videoElement != null, "  (").concat(window.location.href, ")"));
            if (videoElement == null) {
                // forward to iframes in iframes
                var iframes = document.querySelectorAll("iframe");
                for (var i = 0; i < iframes.length; i++) {
                    var iframe = iframes[i];
                    (_a = iframe.contentWindow) === null || _a === void 0 ? void 0 : _a.postMessage(msg.data, "*");
                }
                return;
            }
            switch (action) {
                case "play":
                    videoElement === null || videoElement === void 0 ? void 0 : videoElement.play();
                    break;
                case "pause":
                    videoElement === null || videoElement === void 0 ? void 0 : videoElement.pause();
                    break;
                case "seek":
                    var seekTo = msg.data.seekTo;
                    if (videoElement != null) {
                        videoElement.currentTime = seekTo;
                    }
                    break;
                case "forward":
                    if (videoElement != null) {
                        var seconds = msg.data.seconds;
                        videoElement.currentTime = Math.min(videoElement.duration, videoElement.currentTime + seconds);
                    }
                    break;
                case "rewind":
                    if (videoElement != null) {
                        var seconds = msg.data.seconds;
                        videoElement.currentTime = Math.max(0, videoElement.currentTime - seconds);
                    }
                    break;
                case "onFullscreen":
                    if (videoElement != null) {
                        // set event listener for position change
                        videoElement.addEventListener("timeupdate", timeUpdateCallback);
                    }
                    break;
            }
        }
        window.addEventListener("message", receiver, false);
    }
})();
