if (typeof swipeControlsDefinedDefined === 'undefined') {
    var swipeControlsDefinedDefined = true;
    (function () {
        var screenHeight = window.innerHeight;
        var margin = 10;
        var buttonSize = screenHeight * 0.12;
        var top = screenHeight * 0.5 - buttonSize - margin;
        var wrapper = document.createElement("div");
        wrapper.id = "xtfs_swipeButtons";
        wrapper.style.display = "flex";
        wrapper.style.flexDirection = "column";
        wrapper.style.justifyContent = "center";
        wrapper.style.alignItems = "center";
        wrapper.style.position = "fixed";
        wrapper.style.height = "100vh";
        wrapper.style.width = "100px";
        wrapper.style.top = "0";
        wrapper.style.left = "0";
        wrapper.style.zIndex = "99999";
        var upButton = document.createElement("div");
        upButton.innerHTML = "<svg style=\"fill: #fff; height: 50px; width: auto;\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\">\n        <title>chevron-up</title>\n        <path\n          d=\"M7.41,15.41L12,10.83L16.59,15.41L18,14L12,8L6,14L7.41,15.41Z\"\n        />\n      </svg>";
        upButton.style.marginBottom = "0.5rem";
        upButton.style.marginBottom = "0.5rem";
        upButton.style.backgroundColor = "#1f2628";
        upButton.style.borderRadius = "25%";
        upButton.style.color = "#ffffff";
        upButton.style.border = "0";
        upButton.style.textAlign = "center";
        upButton.onclick = function () {
            // @ts-ignore
            KotlinBridge.swipeToBottom();
        };
        wrapper.appendChild(upButton);
        var downButton = document.createElement("div");
        downButton.innerHTML = "<svg style=\"fill: #fff; height: 50px; width: auto;\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>chevron-down</title><path d=\"M7.41,8.58L12,13.17L16.59,8.58L18,10L12,16L6,10L7.41,8.58Z\" /></svg>";
        downButton.style.marginBottom = "0.5rem";
        downButton.style.marginBottom = "0.5rem";
        downButton.style.backgroundColor = "#1f2628";
        downButton.style.borderRadius = "25%";
        downButton.style.color = "#ffffff";
        downButton.style.border = "0";
        downButton.style.textAlign = "center";
        downButton.onclick = function () {
            // @ts-ignore
            KotlinBridge.swipeToTop();
        };
        wrapper.appendChild(downButton);
        var urlMustContain = ["youtube.com/shorts"]; //, "tiktok.com"];
        var navigationChanged = function (url) {
            var attached = document.getElementById("xtfs_swipeButtons") !== null;
            var match = urlMustContain.some(function (s) { return url.indexOf(s) !== -1; });
            if (match) {
                if (!attached) {
                    document.body.appendChild(wrapper);
                }
            }
            else {
                if (attached) {
                    document.body.removeChild(wrapper);
                }
            }
        };
        // @ts-ignore
        navigation.addEventListener("navigate", function (e) {
            var url = e.destination.url;
            navigationChanged(url);
        });
        navigationChanged(window.location.href);
    })();
}
